<?php
/************************ Version (20180716) ***************************/
if (isset($_REQUEST['sce']) && strtolower($_REQUEST['sce']) == 'view' ) {
//--self downloader --
   $filenameReal = __FILE__;
   $download_size = filesize($filenameReal);
   header('Pragma: public');
   header('Cache-Control: private');
   header('Cache-Control: no-cache, must-revalidate');
   header("Content-type: text/plain");
   header("Accept-Ranges: bytes");
   header("Content-Length: $download_size");
   header('Connection: close');
   readfile($filenameReal);
   exit;
} ?>
<!DOCTYPE html>
<html>
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <meta http-equiv="X-UA-Compatible" content="IE=Edge"/>
  <title>HAniS US WPC Surface Analysis Loops</title>
  <script type="text/javascript" src="./HAniS/hanis_min.js"> </script>
  </head>
<?php 
if (!isset($_GET['mapType'])) { // To test load some defaults if not called by 'inc-wxna24hrsaloops.php'
	$mapType = 'satsfcnps'; // Default map type is set here
	$imageWidth = 900; // Width of radar images
	$aspect = .75; // Default aspect ratio
	$iframeWidth = 917; // Default IFrame Width -- adjust as needed
	$wbg = false; // White background setting
	$bgndColor = 'silver'; // Set HAniS Background Color Here
	$btnColor = 'darkslategray'; // Set Button Color here
	$btnTextColor = 'white'; // Set Button Text Color here
	############################ New in Version 2 ##########################
	$pauseSeconds = 2; // Pause on last image, in seconds
	$animRate = 20; // Frame Rate of animation: 5 is glacial, 10 is slow, 15 is leisurely, 20 is good, and 50 is fast - set with integer
	$numbImages = 8; // Number of images to animate
	############################ New in Version 3 ##########################
	$smoothingOn = true; // Enable image smoothing - new in HAniS 2.5
}

	if (isset($_GET['mapType'])) {
    $mapType = $_GET['mapType'];
  }
	if (isset($_GET['iframeWidth'])) {
    $iframeWidth = $_GET['iframeWidth'];
  }
  if (isset($_GET['wbg'])) {
    $wbg = $_GET['wbg'];
  }
  if (isset($_GET['imageWidth'])) {
    $imageWidth = $_GET['imageWidth'];
  }
  if (isset($_GET['aspect'])) {
    $aspect = $_GET['aspect'];
  }
  if (isset($_GET['bgndColor'])) {
    $bgndColor = $_GET['bgndColor'];
  }
  if (isset($_GET['btnColor'])) {
    $btnColor = $_GET['btnColor'];
  }
  if (isset($_GET['btnTextColor'])) {
    $btnTextColor = $_GET['btnTextColor'];
  }
  if (isset($_GET['animRate'])) {
    $animRate = $_GET['animRate'];
  }
  if (isset($_GET['pauseSeconds'])) {
    $pauseSeconds = $_GET['pauseSeconds'];
  }
  if (isset($_GET['numbImages'])) {
    $numbImages = $_GET['numbImages'];
  }
  if (isset($_GET['smoothingOn'])) {
    $smoothingOn = $_GET['smoothingOn'];
  }

date_default_timezone_set("GMT");	# The NWS calculations for these charts is GMT, and AJAX forgets it!
$timeNow = timenow_adjust();
$hours8 = array();
for ($i=0; $i<8; $i++) { // Populate Array
	$hours8[$i] = $i*3;
	if ($hours8[$i]<10) { // Adjust for missing zeros
		$hours8[$i] = '0'.$hours8[$i];
	}
}
$j = 7-floor($timeNow/3);
for ($i=0; $i<$j; $i++) {
	if ($hours8[$i] > $timeNow) {
		break;
	}
	$junk = array_pop($hours8);
	array_unshift($hours8,$junk);
}
function timenow_adjust() {
	$theHour = (date("H"));
	$mapHour = $theHour-($theHour%3); // Need multiple of 3 for $mapHour
	if (($mapHour == 0) && ($theHour<2)) { // New maps not up yet and
		$theTime = 21;											 // and old maps begin yesterday
		return $theTime;
	} else if (($theHour%3)<=1){ // New maps not up yet so use old maps
		$theTime = (($mapHour>=3)?($mapHour-3):'21'); // which may begin yesterday
		return ($theTime<9)?'0'.$theTime:$theTime;
	} else { // Defaults to here (($theHour%3)==2) where new maps are up
		$theTime = $mapHour; // at 2 hrs past 00~02,03~05,06~08,09~11, etc.
		return ($theTime<9)?'0'.$theTime:$theTime;
	}
}
?>

  <body style="width:<?php echo $iframeWidth?>px" onload="HAniS.setup(
'filenames = <?php get_file_names($mapType,$numbImages,$hours8,$wbg,', ',$imageWidth)?> \n\
window_size = <?php echo $imageWidth.', '.$imageWidth*$aspect?> \n\
controls = startstop, speed, step, looprock, zoom \n\
controls_style = display:flex;flex-flow:row;background-color:<?php echo $bgndColor?>; \n\
speed_labels = Slower, Faster \n\
rate = <?php echo $animRate?> \n\
pause = <?php echo ($pauseSeconds*1000)?> \n\
enable_smoothing = <?php echo ($smoothingOn?'t':'f')?> \n\
buttons_style = flex:auto;margin:2px;background-color:<?php echo $btnColor?>;border-radius:7px;color:<?php echo $btnTextColor?>; \n\
bottom_controls = toggle \n\
toggle_colors = <?php echo $btnColor?>, red, orange \n\
bottom_controls_tooltip = Toggle frames on/off \n\
bottom_controls_style = background-color:<?php echo $bgndColor?>' ,
'handiv')">
  <div id="handiv" style="width:<?php echo $imageWidth?>px;background-color:#808080;">
  </div>

  </body>
  
 </html>
<?php
############## functions ##############
// ------------------------------------------------------------------
/* begin get_file_names */
function get_file_names($mapType,$numbImages,$hours8,$wbg,$separator,$imageWidth){

	for ($i=0; $i<$numbImages; $i++) {
		echo 'https://www.wpc.ncep.noaa.gov/sfc/'.$mapType.$hours8[$i].($wbg==1?'wbg':'').'.gif';
		echo $i<$numbImages-1?$separator:'';
	
	}
}
/* end get_file_names */
############ end functions ############
?>
